﻿Imports System.ServiceModel
Imports System.Windows.Input
Imports Vertrag
Imports HilfeTools
Imports System.Threading
Imports System.Net
Imports System.Windows
Imports System.Diagnostics
Imports Vertrag.Vertrag
Imports HilfeTools.HilfeTools
Imports System.ComponentModel

Namespace Client
    Partial Public Class HauptfensterStart
        Inherits Chilfe

        Private objProxy As IvertragAsynchron

        Public _stringContent As String = ""

        Public Property StringContent() As String
            Get
                Return _stringContent
            End Get
            Set(value As String)
                _stringContent = value
                NotifyPropertyChanged("StringContent")
            End Set
        End Property

        Public Property ipAddress() As String
            Get
                Return m_ipAddress
            End Get
            Set(value As String)
                m_ipAddress = value
            End Set
        End Property
        Private m_ipAddress As String

        Public Property portNumber() As String
            Get
                Return m_portNumber
            End Get
            Set(value As String)
                m_portNumber = value
            End Set
        End Property
        Private m_portNumber As String

        Public ReadOnly Property GetDataCommand() As ICommand
            Get
                Return New Cbefehl(AddressOf OnClick)
            End Get
        End Property

        Public Sub OnClick()
            Try
                Dim rmAddres As String = Nothing

                rmAddres = (Convert.ToString((Convert.ToString("net.tcp://") & ipAddress) + ":") & portNumber) + "/IvertragAsynchron"

                Dim nettcpbinding As NetTcpBinding = New NetTcpBinding(SecurityMode.None)
                Dim chFactory As ChannelFactory(Of IvertragAsynchron) = New ChannelFactory(Of IvertragAsynchron)(nettcpbinding)
                nettcpbinding.MaxReceivedMessageSize = 10485760L
                Dim mSpan As TimeSpan = Nothing
                mSpan = New TimeSpan(1200000000L)
                nettcpbinding.SendTimeout = mSpan
                Dim epAddress As New EndpointAddress(rmAddres)
                objProxy = chFactory.CreateChannel(epAddress)
                StringContent = "Anfrage läuft..."
                If objProxy.Ping() Then
                    objProxy.BeginDoIt(Function(asyncResult)
                                           StringContent = objProxy.EndDoIt(asyncResult).Content
                                       End Function, Nothing)
                End If

            Catch ex As Exception
                MessageBox.Show("Leider ist ein Fehler aufgetreten:" & vbCr & vbLf + ex.Message)
            End Try
        End Sub
    End Class
End Namespace